#ifndef __TextureManager_h__
#define __TextureManager_h__

#include <iostream>
#include <string>
#include <map>
#include "SDL.h"
#include "SDL_image.h"


class TextureManager
{
	public:

	    static TextureManager* Instance()
	    {
		if(s_pInstance == 0)
		{
		    s_pInstance = new TextureManager();
		    return s_pInstance;
		}
	       
		return s_pInstance;
	    }

		bool load(std::string fileName, std::string id, SDL_Renderer* pRenderer);

		// draw
		void draw(std::string id, int x, int y, int width, int height, SDL_Renderer* pRenderer, SDL_RendererFlip flip = SDL_FLIP_NONE);
		virtual void drawFrame(std::string id, int x, int y, int width, int height, int currentRow, int currentFrame, SDL_Renderer* pRenderer, SDL_RendererFlip flip = SDL_FLIP_NONE);
		virtual void scaleFrame(std::string id, int x, int y, int width, int height, int scaleWidth, int scaleHeight, int scaleX, int scaleY, int currentRow, int currentFrame, SDL_Renderer* pRenderer, SDL_RendererFlip flip = SDL_FLIP_NONE);


		std::map<std::string, SDL_Texture*> getTextureMap() { 
			return m_textureMap; 
		}

	private:
		    TextureManager() {}
		    ~TextureManager() {}
	
		std::map<std::string, SDL_Texture*> m_textureMap;
		static TextureManager* s_pInstance;
};

typedef TextureManager TheTextureManager;

#endif /* defined(__SDL_Game_Programming_Book__TextureManager__) */
